#!/usr/bin/perl

#
# WEB PATIO : patio.cgi - 2013/05/06
# Copyright (c) KentWeb
# http://www.kent-web.com/
#

# W[錾
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;
use Jcode;

# ݒt@CF
require "./init.cgi";
my %cf = &init;

# f[^
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
&error('eʃI[o[') if ($cgi->truncated);
my %in = &parse_form($cgi);

# F؃[h
my %au = &authent if ($cf{authkey});

# 
if ($in{read}) { &read_log; }
if ($in{edit}) { &pwd_form; }
if ($in{mode} eq 'form') { &form_page; }
if ($in{mode} eq 'find') { &find_page; }
if ($in{mode} eq 'note') { &note_page; }
if ($in{mode} eq 'past') { &past_page; }
&bbs_list;

#-----------------------------------------------------------
#  j[\
#-----------------------------------------------------------
sub bbs_list {
	# A[`
	my $alarm = int ( $cf{m_max} * 0.9 );

	# y[W
	my $pg = $in{pg} || 0;

	# Xbh\
	my ($i,@log);
	open(IN,"$cf{nowfile}") or &error("open err: $cf{nowfile}");
	my $top = <IN>;
	while (<IN>) {
		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{pgmax_now});

		push(@log,$_);
	}
	close(IN);

	# Jz{^쐬
	my $page_btn = &make_pgbtn($i,$pg,$cf{pgmax_now});

	# ev[gǍ
	open(IN,"$cf{tmpldir}/bbs.html") or &error("open err: bbs.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# ev[g
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1,$2,$3);
	} else {
		&error("ev[gsł");
	}

	foreach ($head,$foot) {

		# F؃[h
		if ($cf{authkey}) {
			s/!login-name!/$au{name}/g;
		} else {
			s/<!-- auth_begin -->.+?<!-- auth_end -->//sg;
		}

		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!bbs_title!/$cf{bbs_title}/g;
		s/!homepage!/$cf{homepage}/g;
		s|!ico:(\w+\.\w+)!|<img src="$cf{iconurl}/$1">|g;
		s/!page-btn!/$page_btn/g;
	}

	# F؃NbL[
	if ($cf{authkey} && $in{mode} eq 'login') {
		&set_cookie('CGISESSID',$au{sid});
	}

	# ʕ\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	foreach (@log) {
		chomp;
		my ($num,$sub,$res,$nam,$upd,$last,$key,$upl) = split(/<>/);
		my $ukey = $upl ? 1 : 0;

		# QƃJE^
		open(NO,"$cf{logdir}/$num.dat");
		my $data = <NO>;
		close(NO);
		my ($cnt) = (split(/:/, $data))[0];

		my $tmp = $loop;
		$tmp =~ s/!ico!/&icon($key,$res,$alarm,$upl)/eg;
		$tmp =~ s|!topic!|<a href="$cf{bbs_cgi}?read=$num&ukey=$ukey">$sub</a>|g;
		$tmp =~ s/!name!/$nam/g;
		$tmp =~ s/!res!/$res/g;
		$tmp =~ s/!count!/$cnt/g;
		$tmp =~ s/!update!/$upd/g;
		$tmp =~ s/!last!/$last/g;
		print $tmp;
	}

	# tb^[
	&footer($foot);
}

#-----------------------------------------------------------
#  tH_[ACR
#-----------------------------------------------------------
sub icon {
	my ($key,$res,$alarm,$upl) = @_;

	# ACRf
	my $ico;
	if ($key eq '0') { $ico = 0; }
	elsif ($key == 2) { $ico = 2; }
	elsif ($res >= $alarm) { $ico = 'alerm'; }
	elsif ($upl) { $ico = 'image'; }
	else { $ico = 1; }

	return qq|<img src="$cf{iconurl}/$cf{fld_icon}->{$ico}">|;
}

#-----------------------------------------------------------
#  L{
#-----------------------------------------------------------
sub read_log {
	# NbL[擾
	my ($ck_nam,$ck_eml,$ck_url,$ck_mlo) = &get_cookie;
	$ck_url ||= 'http://';

	# ACR
	my $smile;
	my @smile = split(/\s+/, $cf{smile});
	foreach (0 .. $#smile) {
		$smile .= qq|<a href="javascript:face('{ico:$_}')"><img src="$cf{iconurl}/$smile[$_]"></a>|;
	}

	# A[`
	my $alarm = int ( $cf{m_max} * 0.9 );

	# y[W`
	my $pg = $in{pg} || 0;

	# Xbhǂݍ
	$in{read} =~ s/\D//g;
	my @log;
	open(IN,"$cf{logdir}/$in{read}.cgi") or &error("open err: $in{read}.cgi");
	my $top = <IN>;
	my $par = <IN>;
	my ($no,$sub,$res,$key) = split(/<>/, $top);

	my $i = 0;
	while(<IN>) {
		$i++;
		next if ($i <= $res - $cf{pg_max} - $pg);
		last if ($i > $res - $pg);

		unshift(@log,$_);
	}
	close(IN);

	# ԐMtH[
	my $resfm = 1;
	if ($key != 1 || $in{log} eq 'past') {
		$resfm = 0;
	}

	# Jz{^쐬
	my $page_btn = &make_pgbtn($res, $pg, $cf{pg_max}, "read=$in{read}");

	# ev[gǍ
	open(IN,"$cf{tmpldir}/read.html") or &error("open err: read.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 摜F؍쐬
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0 && $resfm) {
		require $cf{captcha_pl};
		($str_plain, $str_crypt) = cap::make( $cf{captcha_key}, $cf{cap_len} );
	} else {
		$tmpl =~ s/<!-- captcha_begin -->.+<!-- captcha_end -->//s;
	}

	# email\
	my $op_mlo;
	my @mlo = ('\','\');
	foreach (1,0) {
		if ($ck_mlo eq $_) {
			$op_mlo .= qq|<option value="$_" selected>$mlo[$_]\n|;
		} else {
			$op_mlo .= qq|<option value="$_">$mlo[$_]\n|;
		}
	}

	# eL
	my ($no2,$sub,$nam,$eml,$com,$date,$ho,$pw,$url,$mlo,$myid,$tim,$up1,$up2,$up3) = split(/<>/, $par);
	$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml && $mlo);
	$url &&= qq|<a href="$url" target="_blank">$url</a>|;
	$com =~ s/\{ico:(\d+)\}/<img src="$cf{iconurl}\/$smile[$1]">/g;
	$com = &autolink($com) if ($cf{autolink});

	# 摜
	$com = &image($com,$tim,$up1,$up2,$up3);

	# tH[p
	my $resub = $sub =~ /^Re:/ ? $sub : "Re: $sub";

	# u
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!ico!/&icon($key,$res,$alarm,$in{ukey})/eg;
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!date!/$date/g;
	$tmpl =~ s/!name!/$nam/g;
	$tmpl =~ s/!url!/$url/g;
	$tmpl =~ s/!comment!/$com/g;
	$tmpl =~ s|!ico_edit!|<a href="$cf{bbs_cgi}?edit=$in{read}&no=0"><img src="$cf{iconurl}/pg_edit.gif" alt="LҏW"></a>|g;
	$tmpl =~ s/!page_btn!/$page_btn/g;
	$tmpl =~ s/!res!/$in{read}/g;

	# F؃[h
	if ($cf{authkey}) {
		$tmpl =~ s/!id!/$myid/g;
	} else {
		$tmpl =~ s/<!-- id_begin -->.+?<!-- id_end -->//s;
	}

	# ԐMtH[/ҏW{^
	if (!$resfm) {
		$tmpl =~ s/<!-- resform_begin -->.+<!-- resform_end -->//sg;
		$tmpl =~ s/<!-- edit_begin -->.+?<!-- edit_end -->//sg;
	} else {
		$tmpl =~ s/!str_crypt!/$str_crypt/g;
		$tmpl =~ s/!fm_sub!/$resub/g;
		$tmpl =~ s/!fm_name!/$ck_nam/g;
		$tmpl =~ s/!fm_email!/$ck_eml/g;
		$tmpl =~ s/!fm_url!/$ck_url/g;
		$tmpl =~ s/!smile!/$smile/g;
		$tmpl =~ s/<!-- op_mlo -->/$op_mlo/g;
	}

	# ev[g
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1,$2,$3);
	} else {
		&error("ev[gsł");
	}

	# wb_\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	# XL
	foreach (@log) {
		my ($no,$sub,$nam,$eml,$com,$date,$ho,$pw,$url,$mlo,$myid,$tim,$up1,$up2,$up3) = split(/<>/);
		$nam = qq|<a href="mailto:$eml">$nam</a>| if ($eml && $mlo);
		$url &&= qq|<a href="$url" target="_blank">$url</a>|;
		$com =~ s/\{ico:(\d+)\}/<img src="$cf{iconurl}\/$smile[$1]">/g;
		$com = &autolink($com) if ($cf{autolink});

		# 摜
		$com = &image($com,$tim,$up1,$up2,$up3);

		my $tmp = $loop;
		$tmp =~ s|!ico:(\w+\.\w+)!|<img src="$cf{iconurl}/$1" alt="">|g;
		$tmp =~ s/!res_sub!/$sub/g;
		$tmp =~ s/!res_date!/$date/g;
		$tmp =~ s/!res_name!/$nam/g;
		$tmp =~ s/!res_url!/$url/g;
		$tmp =~ s/!res_com!/$com/g;
		$tmp =~ s|!res_ico_edit!|<a href="$cf{bbs_cgi}?edit=$in{read}&no=$no"><img src="$cf{iconurl}/pg_edit.gif" alt="LҏW"></a>|g;

		# F؃[h
		if ($cf{authkey}) {
			$tmp =~ s/!res_id!/$myid/g;
		} else {
			$tmp =~ s/<!-- id_begin -->.+?<!-- id_end -->//s;
		}

		print $tmp;
	}

	# JEgAbv
	&count_up;

	# tb^[
	&footer($foot);
}

#-----------------------------------------------------------
#  F؃tH[
#-----------------------------------------------------------
sub pwd_form {
	# `FbN
	$in{edit} =~ s/\D//g;
	$in{no} =~ s/\D//g;

	# L
	my ($name,$pwd);
	open(IN,"$cf{logdir}/$in{edit}.cgi") or &error("open err: $in{edit}.cgi");
	my $top = <IN>;
	while(<IN>) {
		my ($no,$sub,$nam,$eml,$com,$dat,$ho,$pw,$url,$mlo,$myid,$tim,$upl1,$upl2,$upl3) = split(/<>/);

		if ($in{no} == $no) {
			$name = $nam;
			$pwd = $pw;
			last;
		}
	}
	close(IN);

	# pX[hݒ
	&error("̋L̓pX[hݒ̂ߕҏWł܂") if ($pwd eq '');

	# IIvV
	my $op_job = qq|<option value="edit" selected>LҏW\n|;
	if ($in{no} == 0) {
		$op_job .= qq|<option value="lock">XbhbN\n|;
	} else {
		$op_job .= qq|<option value="dele">L폜\n|;
	}

	# Lf[^
	my ($no,$sub,$res,$key) = split(/<>/, $top);

	# ev[gǂݍ
	open(IN,"$cf{tmpldir}/pwd.html") or &error("open err: pwd.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# u
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!name!/$name/g;
	$tmpl =~ s/!art!/$in{edit}/g;
	$tmpl =~ s/!no!/$in{no}/g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s|!ico:(\w+\.\w+)!|<img src="$cf{iconurl}/$1">|g;
	$tmpl =~ s/<!-- op_job -->/$op_job/g;

	# ʕ\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  ӎ\
#-----------------------------------------------------------
sub note_page {
	# ev[gǂݍ
	open(IN,"$cf{tmpldir}/note.html") or &error("open err: note.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# u
	$tmpl =~ s/!maxdata!/$cf{maxdata}oCg/g;
	$tmpl =~ s/!max_w!/$cf{max_img_w}/g;
	$tmpl =~ s/!max_h!/$cf{max_img_h}/g;

	# ʕ\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  摜\
#-----------------------------------------------------------
sub image {
	my ($com,$fnam,$up1,$up2,$up3) = @_;
	my %img = (1 => $up1, 2 => $up2, 3 => $up3);

	my $img;
	foreach my $i (1 .. 3) {
		my ($ex,$w,$h) = split(/,/, $img{$i});
		if ($ex) {
			($w,$h) = &resize($w,$h);
			my $pic = -e "$cf{uplurl}/$fnam-s-$i$ex" ? "$fnam-s-$i$ex" : "$fnam-$i$ex";
			$img .= qq|<a href="$cf{uplurl}/$fnam-$i$ex" target="_blank"><img src="$cf{uplurl}/$pic" width="$w" height="$h" hspace="2"></a>|;
		}
	}
	if ($img) {
		return "$com<p>$img</p>";
	} else {
		return $com;
	}
}

#-----------------------------------------------------------
#  etH[
#-----------------------------------------------------------
sub form_page {
	# NbL[擾
	my ($ck_nam,$ck_eml,$ck_url,$ck_mlo) = &get_cookie;
	$ck_url ||= 'http://';

	# ACR
	my $smile;
	my @smile = split(/\s+/, $cf{smile});
	foreach (0 .. $#smile) {
		$smile .= qq|<a href="javascript:face('{ico:$_}')"><img src="$cf{iconurl}/$smile[$_]"></a>|;
	}

	# ev[gǂݍ
	open(IN,"$cf{tmpldir}/form.html") or &error("open err: form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# email\
	my $op_mlo;
	my @mlo = ('\','\');
	foreach (1,0) {
		if ($ck_mlo eq $_) {
			$op_mlo .= qq|<option value="$_" selected>$mlo[$_]\n|;
		} else {
			$op_mlo .= qq|<option value="$_">$mlo[$_]\n|;
		}
	}

	# 摜F؍쐬
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain, $str_crypt) = cap::make( $cf{captcha_key}, $cf{cap_len} );
	} else {
		$tmpl =~ s/<!-- captcha_begin -->.+<!-- captcha_end -->//s;
	}

	# u
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!ico:(\w+\.\w+)!/<img src="$cf{iconurl}\/$1">/g;
	$tmpl =~ s/!str_crypt!/$str_crypt/g;
	$tmpl =~ s/!name!/$ck_nam/g;
	$tmpl =~ s/!email!/$ck_eml/g;
	$tmpl =~ s/!url!/$ck_url/g;
	$tmpl =~ s/!smile!/$smile/g;
	$tmpl =~ s/<!-- op_mlo -->/$op_mlo/g;

	# ʕ\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  
#-----------------------------------------------------------
sub find_page {
	# ev[gǂݍ
	open(IN,"$cf{tmpldir}/find.html") or &error("open err: find.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 
	if ($in{cond} eq '') { $in{cond} = 1; }
	my $op_cond;
	my %cond = (1 => 'AND', 0 => 'OR');
	foreach (1,0) {
		if ($in{cond} == $_) {
			$op_cond .= qq|<option value="$_" selected>$cond{$_}\n|;
		} else {
			$op_cond .= qq|<option value="$_">$cond{$_}\n|;
		}
	}
	# ͈
	$in{area} ||= 1;
	my %area = (1 => 'sO', 2 => 'ߋO');
	my $area;
	foreach (1,2) {
		if ($in{area} == $_) {
			$area .= qq|<input type="radio" name="area" value="$_" checked>$area{$_}\n|;
		} else {
			$area .= qq|<input type="radio" name="area" value="$_">$area{$_}\n|;
		}
	}

	# u
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!ico:(\w+\.\w+)!/<img src="$cf{iconurl}\/$1">/g;
	$tmpl =~ s/<!-- op_cond -->/$op_cond/g;
	$tmpl =~ s/!area!/$area/g;
	$tmpl =~ s/!word!/$in{word}/g;

	# s
	if ($in{word} ne '') {

		my ($head,$loop,$foot);
		if ($tmpl =~ /(.+)<!-- search_begin -->(.+)<!-- search_end -->(.+)/s) {
			($head,$loop,$foot) = ($1,$2,$3);
		} else {
			&error("ev[gsł$tmpl");
		}

		# ʕ\
		print "Content-type: text/html; charset=shift_jis\n\n";
		print $head;
		&search($loop);
		print $foot;
		exit;

	# O
	} else {

		$tmpl =~ s/<!-- search_begin -->.+<!-- search_end -->//s;

		# ʕ\
		print "Content-type: text/html; charset=shift_jis\n\n";
		print $tmpl;
		exit;
	}
}

#-----------------------------------------------------------
#  s
#-----------------------------------------------------------
sub search {
	my $loop = shift;
	$loop =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s;
	my ($head,$loop,$foot) = ($1,$2,$3);

	# L[[h
	Jcode::convert(\$in{word}, 'sjis');
	$in{word} =~ s/@/ /g;
	my @wd = split(/\s+/, $in{word});

	# Ώ۔͈/
	my ($idx,$param);
	if ($in{area} == 1) {
		$idx = $cf{nowfile};
	} else {
		$idx = $cf{pastfile};
		$param = "&log=past";
	}

	# L[[hiShift-JIS`j
	my $ascii = '[\x00-\x7F]';
	my $hanka = '[\xA1-\xDF]';
	my $kanji = '[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC]';

	# indexI[v
	my @find;
	open(IN,"$idx") or &error("open err: $idx");
	my $top = <IN>;
	while(<IN>) {
		my ($num,$sub,$res,$nam,$upd,$last,$key,$upl) = split(/<>/);

		# eXbhǂݍ
		open(LOG,"$cf{logdir}/$num.cgi");
		my $log = join('', <LOG>);
		close(LOG);

		# Xbh
		my $flg;
		foreach my $wd (@wd) {
			if ($log =~ /^(?:$ascii|$hanka|$kanji)*?\Q$wd\E/i) {
				$flg++;
				if ($in{cond} == 0) { last; }
			} else {
				if ($in{cond} == 1) { $flg = 0; last; }
			}
		}
		if ($flg) { push(@find,$_); }
	}
	close(IN);

	# qbg
	my $hit = @find;
	$head =~ s/!hit!/$hit/g;
	$foot =~ s/!hit!/$hit/g;

	# A[`
	my $alarm = int ( $cf{m_max} * 0.9 );

	# ʕ\
	print $head;
	foreach (@find) {
		my ($num,$sub,$res,$nam,$upd,$last,$key,$upl) = split(/<>/);
		my $ukey = $upl ? 1 : 0;

		my $tmp = $loop;
		$tmp =~ s/!icon!/&icon($key,$res,$alarm,$upl)/eg;
		$tmp =~ s|!sub!|<a href="$cf{bbs_cgi}?read=$num&ukey=$ukey$param">$sub</a>|g;
		$tmp =~ s/!name!/$nam/g;
		$tmp =~ s/!res!/$res/g;
		$tmp =~ s/!update!/$upd/g;
		print $tmp;
	}
	print $foot;
}

#-----------------------------------------------------------
#  ߋOy[W
#-----------------------------------------------------------
sub past_page {
	# y[W
	my $pg = $in{pg} || 0;

	# Xbh\
	my ($i,@log);
	open(IN,"$cf{pastfile}") or &error("open err: $cf{pastfile}");
	while (<IN>) {
		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{pgmax_past});

		push(@log,$_);
	}
	close(IN);

	# Jz{^쐬
	my $page_btn = &make_pgbtn($i, $pg, $cf{pgmax_past}, "mode=past");

	# ev[gǂݍ
	open(IN,"$cf{tmpldir}/past.html") or &error("open err: past.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# u
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!ico:(\w+\.\w+)!/<img src="$cf{iconurl}\/$1">/g;
	$tmpl =~ s/!page-btn!/$page_btn/g;

	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1,$2,$3);
	} else {
		&error("ev[gsł");
	}

	# ʕ\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	foreach (@log) {
		my ($num,$sub,$res,$nam,$upd,$last,$key,$upl) = split(/<>/);

		my $tmp = $loop;
		$tmp =~ s|!icon!|<img src="$cf{iconurl}/fld_nor.gif">|;
		$tmp =~ s|!sub!|<a href="$cf{bbs_cgi}?read=$num&log=past">$sub</a>|g;
		$tmp =~ s/!name!/$nam/g;
		$tmp =~ s/!res!/$res/g;
		$tmp =~ s/!update!/$upd/g;
		print $tmp;
	}

	# tb^[
	&footer($foot);
}

#-----------------------------------------------------------
#  tb^[
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 쌠\Li폜Eϋ֎~j
	my $copy = <<EOM;
<p style="margin-top:2.5em;text-align:center;font-family:Verdana,Arial,Helvetica;font-size:10px;">
- <a href="http://www.kent-web.com/" target="_top">WEB PATIO</a> -
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  Jz{^쐬
#-----------------------------------------------------------
sub make_pgbtn {
	my ($i, $pg, $max, $param) = @_;
	$max ||= 10;

	# 
	$param &&= "&$param";

	# y[WJz`
	my $next = $pg + $max;
	my $back = $pg - $max;

	# y[WJz{^쐬
	my $pg_btn;
	if ($back >= 0 || $next < $i) {
		$pg_btn .= "Page: ";

		my ($x, $y) = (1, 0);
		while ($i > 0) {
			if ($pg == $y) {
				$pg_btn .= qq(| <b>$x</b> );
			} else {
				$pg_btn .= qq(| <a href="$cf{bbs_cgi}?pg=$y$param">$x</a> );
			}
			$x++;
			$y += $max;
			$i -= $max;
		}
		return qq!<p class="pg-btn">$pg_btn|</p>!;
	} else {
		return;
	}
}

#-----------------------------------------------------------
#  JEgAbv
#-----------------------------------------------------------
sub count_up {
	# IP擾
	my $addr = $ENV{REMOTE_ADDR};

	# JEgf[^I[v
	open(DAT,"+< $cf{logdir}/$in{read}.dat") or &error("open err: $in{read}.dat");
	eval "flock(DAT, 2);";
	my $data = <DAT>;
	my ($cnt,$ip) = split(/:/, $data);

	# IP`FbN
	if ($addr ne $ip) {
		$cnt++;
		seek(DAT, 0, 0);
		print DAT "$cnt:$addr";
		truncate(DAT, tell(DAT));
	}
	close(DAT);
}

#-----------------------------------------------------------
#  F؃[h
#-----------------------------------------------------------
sub authent {
	# ZbVW[荞
	require $cf{session_pl};

	# OC
	if ($in{mode} eq 'login') {
		# ̓`FbN
		if ($in{id} eq '' || $in{pw} eq '') {
			&error("ID܂̓pX[h͂ł");
		}
		# ZbV쐬
		&make_ses($in{id},$in{pw},$cf{memfile},$cf{sesdir},$cf{authtime});

	# OIt
	} elsif ($in{mode} eq 'logoff') {
		# ZbV폜
		&del_ses($cf{sesdir});

		# 
		&enter_form('cook_del');

	# 
	} elsif ($in{mode} eq 'enter') {
		&enter_form;

	# ZbVǗ
	} else {
		&session($cf{sesdir},$cf{bbs_cgi});
	}
}

#-----------------------------------------------------------
#  
#-----------------------------------------------------------
sub enter_form {
	my $ck = shift;

	# ev[gǂݍ
	open(IN,"$cf{tmpldir}/enter.html") or &error("open err: enter.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# u
	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;

	# NbL[r
	if ($ck eq 'cook_del') {
		&set_cookie('CGISESSID','','del');
	}

	# ʕ\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  cryptƍ
#-----------------------------------------------------------
sub decrypt {
	my ($in, $dec) = @_;

	my $salt = $dec =~ /^\$1\$(.*)\$/ ? $1 : substr($dec, 0, 2);
	if (crypt($in, $salt) eq $dec || crypt($in, '$1$' . $salt) eq $dec) {
		return 1;
	} else {
		return 0;
	}
}

#-----------------------------------------------------------
#  NbL[擾
#-----------------------------------------------------------
sub get_cookie {
	# NbL[擾
	my $cook = $ENV{HTTP_COOKIE};

	# YIDo
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLfR[h
	my @cook;
	foreach ( split(/<>/, $cook{$cf{cookie_id}}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  NbL[s
#-----------------------------------------------------------
sub set_cookie {
	my ($key,$val,$del) = @_;

	# Ԓ`
	my $gtime = $del eq 'del' ? time - 365*24*60*60 : time + 60*24*60*60;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime($gtime);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# tH[}bg
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	print "Set-Cookie: $key=$val; expires=$gmt\n";
}

#-----------------------------------------------------------
#  N
#-----------------------------------------------------------
sub autolink {
	my $text = shift;

	$text =~ s/(s?https?:\/\/([\w-.!~*'();\/?:\@=+\$,%#]|&amp;)+)/<a href="$1" target="_blank">$1<\/a>/g;
	return $text;
}

